// JavaScript Slide Presentation software.
// Copyright 2003-2010 by Akkana Peck.
// This software is licensed under the GNU public license --
// Share and enjoy!

// See a presentation on how to use it at
// http://shallowsky.com/linux/presentations/

//
// Slide navigation. List your slides here, in order.
//
var slides = new Array ( "index.html",

                         //"notatutorial.html",
                         "lotsamenus.html",

                         "languages.html",

                         // Python starts here
                         "python.html",
                         //"steal.html",
                         "helloworld-py.html",
                         //"helloworld-py-parms-shot.html",
                         "helloworld-py-shot.html",
                         "helloworld-py-import.html",
                         "helloworld-py-define.html",
                         "helloworld-py-img.html",
                         "helloworld-py-fg.html",
                         "helloworld-py-text.html",
                         "helloworld-py-resize.html",
                         "helloworld-py-display.html",

                         "customizing.html",
                         "comicsans.html",
                         "comicsans2.html",
                         "comicsans3.html",

                         // Registration
                         "pyreg-title.html",
                         "pyreg.html",
                         "pyreg-str.html",
                         "pyreg-id.html",
                         //"pyreg-help.html",
                         "pyreg-help2.html",
                         "pyreg-author.html",
                         "pyreg-menustr.html",
                         "pyreg-menustr2.html",
                         "pyreg-imgtype.html",
                         "pyreg-imgtype2.html",

                         // UI params
                         "pyreg-params.html",
                         "pyreg-params2.html",
                         "py-ui-params.html",
                         "pyreg-outprm.html",

                         "pyreg-fcn.html",
                         "pyreg-main.html",

                         // How to install
                         "installing.html",
                         "where.html",
                         //"tools-vs-filters.html",
                         "plugin-vs-script.html",
                         //"plugin-vs-script2.html",
                         "consistency.html",

                         "chmod.html",
                         "restart-gimp.html",

                         // PDB browser
                         "pdbintro.html",
                         "pyobjectcode-pdb.html",
                         "pdb-browser.html",
                         "pdb-browser-shot.html",
                         "pdb-fontname.html",

                         "pdb-to-python.html",
                         "pdb-to-python2.html",
                         "pdb-to-python3.html",

                         "py-docs.html",

                         //"new-layer.html",
                         //"new-layer-py.html",

                         //"py-extras.html",

                         "custom-dialogs.html",
                         //"ratio-info.html",
                         "arrow.html",
                         "arrow-code.html",
                         "life-dialog.html",

                         //"py-extras2.html",
                         "py-pixels.html",
                         "tiles.html",
                         "pixelrgns.html",
                         //"tiles-and-regions.html",
                         "speed.html",
                         "less-speed.html",

                         "py-debug-title.html",
                         "py-console.html",
                         "py-getting-images.html",
                         //"py-console-images.html",

                         "py-debugging-print.html",
                         "py-debugging.html",
                         "py-debuggers.html",

                         "py-disadvantages.html",

                         // Script-fu
                         "script-fu-title.html",
                         "script-fu.html",
                         "tiny-fu.html",
                         "kittens.html",

                         "script-fu-bennies.html",
                         "turtle.html",

                         // Hello world in script-fu
                         "sf-hello.html",
                         "sf-hello-img.html",
                         "sf-hello-fontname.html",
                         "sf-hello-resize.html",

                         //"ui-register.html",
                         "2partreg.html",

                         "sf-install.html",
                         "refresh-scripts.html",

                         //"your-own-script.html",
                         //"registering.html",
                         //"menu.html",
                         //"menu-struct.html",
                         //"adjustment.html",
                         //"dialog.html",

                         "lisp-syntax.html",
                         "sf-let.html",
                         "sf-letstar.html",

                         //"let.html",
                         "carsrc.html",
                         //"car.html",
                         "lists.html",

                         "lisp-if.html",
                         "lisp-if2.html",
                         "lisp-if-yoda.html",
                         "lisp-if-wilber.html",
                         "lisp-harder-if.html",
                         "lisp-harder-if2.html",
                         //"lisp-begin.html",
                         //"lisp-loops.html",

                         "sf-debugging.html",
                         "sf-console.html",
                         "sf-console2.html",
                         //"sf-console3.html",
                         "sf-console4.html",
                         "sf-console5.html",

                         "gimp-message.html",
                         "typical-scheme-errors.html",
                         //"tiny-errors.html",
                         "solomon.html",
                         "solomon2.html",
                         "solomon3.html",
                         "solomon-summary.html",

                         "scriptfu-doc.html",

                         // Done with script-fu, on to general stuff
                         "miscellany.html",

                         "finding-src.html",
                         "gimpsrc.html",


                         "summary.html");

var xlides = new Array ( "gimpscripting.html",
                         "simplepy.html",
                         "simplepy-gimpfu.html",
                         "simplepy-dostuff.html",
                         "simplepy-register.html",
                         "simplepy-names.html",
                         "simplepy-menu.html", "simplepy-menu2.html",
                         "simplepy-rgb.html",
                         "simplepy-params.html",
                         "simplepy-fcn.html",

                         "menushot.html",

                         "do-stuff-shot.html",
                         "ui-params-code.html",
                         //"py-ui-code.html",
                         "nums-txt.html",
                         "spinslide.html",
                         "pycolor.html",
                         "py-img-layer.html",
                         "bools-radio.html",
                         "filesdirs.html",
                         "stuffpickers.html",

                         "python-objects.html",
                         "pyobjectcode.html",
                         "pyobjectcode-gimp.html",
                         "gimpobject.html",
                         "gimpobject2.html",
                         "gimpobject3.html",
                         "pyobjectcode-img.html",

                         "imageobject.html",
                         "imageobjectfcns.html",
                         "layerobject.html",
                         "layerobject-fcns.html",

                         "summary.html");

//
// Add the event listener.
// This has to be on keydown or keyup because webkit doesn't
// generate keypress events for nonprintable keys.
if (document.addEventListener) {		// DOM way
  //document.addEventListener("keypress", onKeyPress, false);
  //document.addEventListener("keyup", onKeyPress, false);
  document.addEventListener("keydown", onKeyPress, false);
}
else if (document.all)			// IE way
  document.attachEvent("onkeypress", onKeyPress);

/*
function onKeyUp(e)
{
  alert("key up, char code " + e.charCode + ", key code " + e.keyCode );
}
*/

//
// Keypress navigation
function onKeyPress(e)
{
  // IE doesn't see the event argument passed in, so get it this way:
  if (window.event) e = window.event;

  //alert("key press, char code " + e.charCode + ", key code " + e.keyCode
  //      + ", " + e.ctrlKey + ", " + e.altKey + ", " + e.metaKey );

  // Make sure things like desktop switching don't get caught here:
  if (e.ctrlKey || e.altKey || e.metaKey) {
    return;
  }

  // We only use shift for one thing: the table of contents.
  if (e.shiftKey) {
    switch (e.keyCode) {
      case 33:    // e.DOM_VK_PAGE_UP:
      case 33:    // e.DOM_VK_PAGE_UP:
        tableOfContents();
        e.preventDefault();
    }
    return;
  }

  // Mozilla uses charCode for printable characters, keyCode for unprintables:
  if (e.charCode) {
    switch (e.charCode) {
      case 32:
        nextSlide();
        e.preventDefault();
        return;
      // The Logitech Presenter sends a period from the "blank screen" btn
      case 46:
        blankScreen();
        e.preventDefault();
        return;
    }
  }

  // Use numeric values rather than DOM_VK_* so that non-mozilla browsers
  // might work.
  switch (e.keyCode) {
    case 32:    // e.DOM_VK_SPACE:
    case 34:    // e.DOM_VK_PAGE_DOWN:
    case 39:    // e.DOM_VK_RIGHT:
      nextSlide();
      e.preventDefault();
      return;
    case 8:     // e.DOM_VK_BACK_SPACE:
    case 33:    // e.DOM_VK_PAGE_UP:
    case 37:    // e.DOM_VK_LEFT:
      prevSlide();
      e.preventDefault();
      return;
    case 36:    // e.DOM_VK_HOME:
    //case 38:    // e.DOM_VK_UP:
      firstSlide();
      e.preventDefault();
      return;
    case 35:    // e.DOM_VK_END:
      lastSlide();
      e.preventDefault();
      return;
    // The Logitech Presenter's F5/ESC button sometimes sends ESC,
    // sometimes F5. I can't figure out the rule, so treat them the same:
    case 27:     // e.DOM_VK_ESC:
    case 116:    // e.DOM_VK_F5:
      firstSlide();
      e.preventDefault();
      return;
  }
}

//
// Initialize anything needed to show points one by one.
// To use this, set up an ol or ul with id="points"
// and in the HTML body, call onload="initPoints()"
// By default nothing will be visible to begin with;
// if you want something visible, pass 1 or more as the argument.
//
var points;
var curPoint = 0;
var lastPoint;
function initPoints(num_vis)
{
  var numvis = (typeof(num_vis) == 'undefined' ? 1 : num_vis)

  // Set up the point nav:
  var pointList = document.getElementById("points");
  if (pointList) {
    points = pointList.getElementsByTagName("li");
    // Make the first point visible (they should all be invisible initially)
    //points[curPoint].style.visibility = "visible";
  }
  while (numvis > 0) {
    points[curPoint].style.visibility = "visible";
    curPoint = curPoint + 1;
    numvis = numvis - 1;
  }
}

function indexOfPage() {
  var url = document.URL;
  var lastslash = document.URL.lastIndexOf("/");
  var filename = url.substring(lastslash+1, url.length);

  // JS 1.6 has Array.indexOf, but that doesn't work in Opera/Konq/etc.
  if (slides.indexOf) return slides.indexOf(filename);
  var i;
  for (i=0; i<slides.length; ++i) {
    if (slides[i] == filename) return i;
  }
  return 0;
}

function nextSlide() {
  // If there are multiple points on this slide, show the next point:
  if (points && curPoint < points.length) {
    // Make old-current point a more subtle color,
    // to emphasize only the new-current point.
    if (curPoint > 0)
        points[curPoint-1].setAttribute("class", "greyed");
    points[curPoint].style.visibility = "visible";
    curPoint = curPoint + 1;

    return;
  }

  // No next point -- go to the next slide instead.
  var i = indexOfPage();
  if (i >= slides.length - 1) {    // last slide
    //window.alert("That's the last slide");
    return;
  }
  window.location = slides[i+1];
}

function firstSlide() {
  window.location=slides[0];
}

function lastSlide() {
  window.location=slides[slides.length-1];
}

/* Toggle the screen black or not */
function blankScreen() {
  var allblack = document.getElementById("allblack");
  if (allblack) {
    var vis = allblack.style.visibility;
    if (vis == "hidden") {
      allblack.style.visibility = "visible";
    }
    else {
      allblack.style.visibility = "hidden";
    }
  }
  else {
    var body = document.getElementsByTagName("body")[0];
    allblack = document.createElement("div");
    allblack.id = "allblack";
    allblack.style.position = "absolute";
    allblack.style.left = "0";
    allblack.style.top = "0";
    allblack.style.width = "100%";
    allblack.style.height = "100%";
    allblack.style.background = "black";
    allblack.style.zIndex = 100;
    allblack.style.visibility = "visible";
    body.appendChild(allblack);
  }
}

function tableOfContents() {
  // First make a list of all our slides:
  var text = "<h2>Table of Contents</h2>\n<small>\n";
  var i;
  for (i=0; i<slides.length; ++i)
    text += '<a href="' + slides[i] + '">' + slides[i] + '</a><br>\n'
  text += "</small>\n"
  body = document.getElementsByTagName("body")[0];
  body.innerHTML = text;
}

function prevSlide() {
  var i = indexOfPage();
  if (i <= 0) {    // last slide
    //window.alert("Already on the first slide");
    return;
  }
  window.location = slides[i-1];
}

